.model small ; "program.exe                                 /?"
.stack 100h
.data
	pranesimas1	DB "Iveskite du 16-tainius skaitmenis", 13, 10, "$"; 0000h
	pranesimas2	DB "Neteisinga ivestis", 13, 10, "$" ; 0024h
	pranesimas3 DB "Programa konvertuoja 16taini formata i 10taini", 13, 10, "$"
	buffer 		DB 10, ?, 10 dup (0) ; 10, ?, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	new_line	DB 10, 13, "$"
.code

pradzia:
	MOV AX, @data ; AX = @data
	MOV DS, AX ; MOV DS, @data ? 
	
	MOV BX, 81h ;81h - konstanta ES parametrai

tikrinam:
	MOV AX, ES:[BX]	; /? -> AL = /; AH = ?
	INC BX ; BX++

	CMP AL, 13
	JE toliau
	CMP AL, 20h ; 20h = " "
	JE tikrinam
	CMP AX, "?/"
	JNE toliau
	MOV AX, ES:[BX]
	CMP AH, 13 ;AL ? AH 13
	JE help
	JMP toliau

help:	
	MOV DX, offset pranesimas3
	MOV AH, 09h
	INT 21h
	
	JMP pabaiga
	
toliau:
	
	MOV DX, offset pranesimas1
	MOV AH, 09h
	INT 21h
	
	MOV DX, offset buffer
	MOV AH, 0Ah
	INT 21h

	PUSH AX
	MOV DX, offset new_line
	MOV AH, 09h
	INT 21h
	POP AX
	
	MOV SI, offset buffer
	ADD SI, 2
	MOV AX, [DS:SI]
	
	CMP AH, 30h
	JB klaida
	CMP AH, 3Ah
	JB AHskaicius
	CMP AH, 41h
	JB klaida
	CMP AH, 47h
	JNAE AHraide 
	JMP klaida
	
AHskaicius:
	SUB AH, 48
	JMP prieAL
	
AHraide:
	SUB AH, 55
	
prieAL:
	CMP AL, 30h
	JB klaida
	CMP AL, 3Ah
	JB ALskaicius
	CMP AL, 41h
	JB klaida
	CMP AL, 47h
	JB ALraide
	JMP klaida
	
ALskaicius:
	SUB AL, 48
	JMP konversija

ALraide:
	SUB AL, 55
	JMP konversija

klaida:
	MOV DX, offset pranesimas2
	MOV AH, 09h
	INT 21h
	JMP pabaiga	
	
konversija:
	XOR BX, BX ; BX = 0; BH = 0; BL = 0;
	MOV BL, 16
	PUSH AX
	MUL BL ; MUL BL -> AX = AL * BL
	POP BX
	ADD AL, BH

	CMP AL, 10
	JB vienzenklis
	CMP AL, 100
	JB dvizenklis
	JMP trizenklis
	
vienzenklis:
	ADD AL, 30h
	
	MOV DL, AL
	MOV AH, 2
	INT 21h
	
	JMP pabaiga
	
dvizenklis:
	MOV BL, 10 ; 36 -> AL = 36 DIV 10 (3); AH = 36 MOD 10 (6)
	DIV BL ;AL := AX DIV BL; AH := AX MOD BL
	PUSH AX
	ADD AL, 30h
	
	MOV DL, AL
	MOV AH, 2
	INT 21h
	
	POP AX
	ADD AH, 30h
	
	MOV DL, AH; MOV A, B -> A = B 
	MOV AH, 2
	INT 21h
	
	JMP pabaiga
	
trizenklis:
	MOV BL, 100
	DIV BL
	PUSH AX
	ADD AL, 30h
	
	MOV DL, AL
	MOV AH, 2
	INT 21h
	
	POP AX
	MOV AL, AH
	XOR AH, AH
	JMP dvizenklis	
	

pabaiga:
	MOV AH, 4Ch
	INT 21h
	
END pradzia
	